@
@
@
@


@ ---------------------------------------------------------------------
@ void memset32B(void *dst, u32 fill, size_t wcount)
@ ---------------------------------------------------------------------
	.section .itcm,"ax", %progbits
	.arm
	.align
	.global memset32B
memset32B:
	mov		r2, r2, lsl #1
	cmp		r2, #16
	bhs		.Lms16b_entry32
	b		.Lms16b_word_loop

@ ---------------------------------------------------------------------
@ void memset16B(void *dst, u16 fill, size_t hwcount)
@ ---------------------------------------------------------------------
	.section .itcm,"ax", %progbits
	.arm
	.align
	.global memset16B
memset16B:
	cmp		r2, #0				@ if(count != 0)
	movnes	r3, r0, ror #2		@	if(dst && (dst&1))
	strmih	r1, [r0], #2		@	{	*dst++= fill;	count--;	}
	submis	r2, r2, #1			@ if(count == 0 || dst == NULL)
	bxeq	lr					@	return;

	orr		r1, r1, lsl #16		@ Prep for word fills.
	cmp		r2, #16
	blo		.Lms16b_word_loop
.Lms16b_entry32:

	@ --- Block run ---
	stmfd	sp!, {r4-r8}	
	mov		r3, r1
	mov		r4, r1
	mov		r5, r1
	mov		r6, r1
	mov		r7, r1
	mov		r8, r1
	mov		r12, r1
.Lms16b_block_loop:
		subs	r2, r2, #16
		stmhsia	r0!, {r1, r3-r8, r12}
		bhi		.Lms16b_block_loop
	ldmfd	sp!, {r4-r8}
	bxeq	lr
	addne	r2, r2, #16			@ Correct for overstep in loop

	@ --- Word run (+ trailing halfword) ---
.Lms16b_word_loop:
		subs	r2, r2, #2
		strhs	r1, [r0], #4
		bhi		.Lms16b_word_loop
	strneh	r1, [r0], #2		@ r2 != 0 means spare hword left
	bx	lr



@ ---------------------------------------------------------------------
@ void bmp16_floodfill_asm(int x, int y, u16 clr, void *dstBase, 
@	u16 dstW, u16 dstH);
@ ---------------------------------------------------------------------

	.extern memset16B

	.text
	.arm
	.align 2
	.global bmp16_floodfill_asm
bmp16_floodfill_asm:
	stmfd	sp!, {r4-r11,lr}

	@ NOTE: all x-values are doubled for use as halfword offsets
	/* Reglist:
		
		r0: x, dstL
		r1: ppx (current pixel pointer)
		r2:	x*2 (right, left, count)
		r3: yx / tmp / clr
		r4: clrNew
		r5: clrOld
		r6: dstW*2
		r7: dstH-1
		r8: dstBase
		r9: top of span-stack
		r10: clrUp
		r11: clrDown	
		ip:	y
	*/

	@ Prep ppx, clrOld, stack
	ldrh	r6, [sp, #36]
	ldrh	r7, [sp, #40]
	mov		r6, r6, lsl #1
	mov		r0, r0, lsl #1
	mla		r4, r6, r1, r3
	ldrh	r5, [r4, r0]
	cmp		r5, r2					@ Old color== new color: nevermind
	beq		.Lbmp16_flood_end

	mov		r8, r3
	mov		r9, sp
	mov		r4, r2

	@ Initial push (merge with prologue?)
	add		r3, r0, r1, lsl #16
	stmfd	sp!, {r3}

	@ While stack not empty, get new span
.Lbmp16_flood_pop:
		ldmfd	sp!, {r3}
		mov		ip, r3, lsr #16		@ y
		eor		r2, r3, ip, lsl #16	@ x
		mla		r0, r6, ip, r8		@ dstL= &dstBase[y*dstW]

		@ Find left (can be optimized more)
.Lbmp16_flood_left:
			ldrh	r3, [r0,r2]
			cmp		r3, r5			@ clr==clrOld
			subeq	r2, r2, #2
			moveqs	r3, r2, asr #31	@ Special for x>=0
			beq		.Lbmp16_flood_left

		@ Prepare for moving right
		add		r2, r2, #2			@ Step back into span
		add		r0, r0, r2			@ 
		sub		r1, r0, #2
		mvn		r10, #0				@ clrUp= clrDown= -1
		mvn		r11, #0

		@# Move right, checking up and down as we go
.Lbmp16_flood_right:
			ldrh	r3, [r1,#2]!
			cmp		r3, r5
			bne		.Lbmp16_flood_fill_line

			@ Check for new upper span
			ldrh	r3, [r1,-r6]
			cmp		r3, r10
			mov		r10, r3
			beq		.Lbmp16_flood_down
			cmp		r3, r5
			bne		.Lbmp16_flood_down
			subs	r3, ip, #1
			@ y-1>=0: we have a new up-span: push it. Push it good
			addge	r3, r2, r3, lsl #16
			stmgefd	sp!, {r3}

			@ Check for new down span
.Lbmp16_flood_down:		
			ldrh	r3, [r1,+r6]
			cmp		r3, r11
			mov		r11, r3
			beq		.Lbmp16_flood_right_chk
			cmp		r3, r5
			bne		.Lbmp16_flood_right_chk
			add		r3, ip, #1
			cmp		r3, r7
			@ y+1<dstH: we have a new up-span: push it.
			addlt	r3, r2, r3, lsl #16
			stmltfd	sp!, {r3}
							
.Lbmp16_flood_right_chk:
			add		r2, r2, #2
			cmp		r2, r6
			bls		.Lbmp16_flood_right

.Lbmp16_flood_fill_line:
		sub		r2, r1, r0
		movs	r2, r2, lsr #1
		mov		r1, r4
		ldrne	r3,=memset16B
		movne	lr, pc
		bxne	r3
/*
		beq		.Lbmp16_flood_skip
		@ DMA stuff. Why doesn't memset16B work quickly?
		@ Because I'm profiling floodfillB AND _asm >_<
		mov		r1, r0
		mov		r3, #4<<24
		add		r0, r3, #0xEC
		str		r4, [r0]
		add		r2, r2, #0x81<<24
		add		r3, r3, #0xD4
		stmia	r3, {r0-r2}
		mov	r11, r11
		add		r0, r3, #8		
.Ldma_busy:
		ldr		r3, [r0]
		cmp		r3, #0
		bmi		.Ldma_busy

.Lbmp16_flood_skip:
*/
		cmp		r9, sp
		bne		.Lbmp16_flood_pop

.Lbmp16_flood_end:
	ldmfd	sp!, {r4-r11,lr}
	bx		lr

@ EOF

